/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.DataInput;
import fr.istic.mML.Evaluation;
import fr.istic.mML.MLChoice;
import fr.istic.mML.MMLModel;
import fr.istic.mML.MMLPackage;
import fr.istic.mML.Variables;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.MMLModelImpl#getInput <em>Input</em>}</li>
 *   <li>{@link fr.istic.mML.impl.MMLModelImpl#getMlChoice <em>Ml Choice</em>}</li>
 *   <li>{@link fr.istic.mML.impl.MMLModelImpl#getVariables <em>Variables</em>}</li>
 *   <li>{@link fr.istic.mML.impl.MMLModelImpl#getEvaluation <em>Evaluation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class MMLModelImpl extends MinimalEObjectImpl.Container implements MMLModel
{
  /**
   * The cached value of the '{@link #getInput() <em>Input</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInput()
   * @generated
   * @ordered
   */
  protected DataInput input;

  /**
   * The cached value of the '{@link #getMlChoice() <em>Ml Choice</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMlChoice()
   * @generated
   * @ordered
   */
  protected MLChoice mlChoice;

  /**
   * The cached value of the '{@link #getVariables() <em>Variables</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVariables()
   * @generated
   * @ordered
   */
  protected Variables variables;

  /**
   * The cached value of the '{@link #getEvaluation() <em>Evaluation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEvaluation()
   * @generated
   * @ordered
   */
  protected Evaluation evaluation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MMLModelImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.MML_MODEL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public DataInput getInput()
  {
    return input;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetInput(DataInput newInput, NotificationChain msgs)
  {
    DataInput oldInput = input;
    input = newInput;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__INPUT, oldInput, newInput);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setInput(DataInput newInput)
  {
    if (newInput != input)
    {
      NotificationChain msgs = null;
      if (input != null)
        msgs = ((InternalEObject)input).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__INPUT, null, msgs);
      if (newInput != null)
        msgs = ((InternalEObject)newInput).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__INPUT, null, msgs);
      msgs = basicSetInput(newInput, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__INPUT, newInput, newInput));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MLChoice getMlChoice()
  {
    return mlChoice;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMlChoice(MLChoice newMlChoice, NotificationChain msgs)
  {
    MLChoice oldMlChoice = mlChoice;
    mlChoice = newMlChoice;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__ML_CHOICE, oldMlChoice, newMlChoice);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setMlChoice(MLChoice newMlChoice)
  {
    if (newMlChoice != mlChoice)
    {
      NotificationChain msgs = null;
      if (mlChoice != null)
        msgs = ((InternalEObject)mlChoice).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__ML_CHOICE, null, msgs);
      if (newMlChoice != null)
        msgs = ((InternalEObject)newMlChoice).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__ML_CHOICE, null, msgs);
      msgs = basicSetMlChoice(newMlChoice, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__ML_CHOICE, newMlChoice, newMlChoice));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Variables getVariables()
  {
    return variables;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVariables(Variables newVariables, NotificationChain msgs)
  {
    Variables oldVariables = variables;
    variables = newVariables;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__VARIABLES, oldVariables, newVariables);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setVariables(Variables newVariables)
  {
    if (newVariables != variables)
    {
      NotificationChain msgs = null;
      if (variables != null)
        msgs = ((InternalEObject)variables).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__VARIABLES, null, msgs);
      if (newVariables != null)
        msgs = ((InternalEObject)newVariables).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__VARIABLES, null, msgs);
      msgs = basicSetVariables(newVariables, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__VARIABLES, newVariables, newVariables));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Evaluation getEvaluation()
  {
    return evaluation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetEvaluation(Evaluation newEvaluation, NotificationChain msgs)
  {
    Evaluation oldEvaluation = evaluation;
    evaluation = newEvaluation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__EVALUATION, oldEvaluation, newEvaluation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setEvaluation(Evaluation newEvaluation)
  {
    if (newEvaluation != evaluation)
    {
      NotificationChain msgs = null;
      if (evaluation != null)
        msgs = ((InternalEObject)evaluation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__EVALUATION, null, msgs);
      if (newEvaluation != null)
        msgs = ((InternalEObject)newEvaluation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.MML_MODEL__EVALUATION, null, msgs);
      msgs = basicSetEvaluation(newEvaluation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.MML_MODEL__EVALUATION, newEvaluation, newEvaluation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MMLPackage.MML_MODEL__INPUT:
        return basicSetInput(null, msgs);
      case MMLPackage.MML_MODEL__ML_CHOICE:
        return basicSetMlChoice(null, msgs);
      case MMLPackage.MML_MODEL__VARIABLES:
        return basicSetVariables(null, msgs);
      case MMLPackage.MML_MODEL__EVALUATION:
        return basicSetEvaluation(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.MML_MODEL__INPUT:
        return getInput();
      case MMLPackage.MML_MODEL__ML_CHOICE:
        return getMlChoice();
      case MMLPackage.MML_MODEL__VARIABLES:
        return getVariables();
      case MMLPackage.MML_MODEL__EVALUATION:
        return getEvaluation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.MML_MODEL__INPUT:
        setInput((DataInput)newValue);
        return;
      case MMLPackage.MML_MODEL__ML_CHOICE:
        setMlChoice((MLChoice)newValue);
        return;
      case MMLPackage.MML_MODEL__VARIABLES:
        setVariables((Variables)newValue);
        return;
      case MMLPackage.MML_MODEL__EVALUATION:
        setEvaluation((Evaluation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.MML_MODEL__INPUT:
        setInput((DataInput)null);
        return;
      case MMLPackage.MML_MODEL__ML_CHOICE:
        setMlChoice((MLChoice)null);
        return;
      case MMLPackage.MML_MODEL__VARIABLES:
        setVariables((Variables)null);
        return;
      case MMLPackage.MML_MODEL__EVALUATION:
        setEvaluation((Evaluation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.MML_MODEL__INPUT:
        return input != null;
      case MMLPackage.MML_MODEL__ML_CHOICE:
        return mlChoice != null;
      case MMLPackage.MML_MODEL__VARIABLES:
        return variables != null;
      case MMLPackage.MML_MODEL__EVALUATION:
        return evaluation != null;
    }
    return super.eIsSet(featureID);
  }

} //MMLModelImpl
